💎一站式轻松地调用各大LLM模型接口,支持GPT4、智谱、星火、月之暗面及文生图 广告
原题链接:[http://acm.hdu.edu.cn/showproblem.php?pid=1501](http://acm.hdu.edu.cn/showproblem.php?pid=1501) **一:原题内容** Problem Description Given three strings, you are to determine whether the third string can be formed by combining the characters in the first two strings. The first two strings can be mixed arbitrarily, but each must stay in its original order. For example, consider forming "tcraete" from "cat" and "tree": String A: cat String B: tree String C: tcraete As you can see, we can form the third string by alternating characters from the two strings. As a second example, consider forming "catrtee" from "cat" and "tree": String A: cat String B: tree String C: catrtee Finally, notice that it is impossible to form "cttaree" from "cat" and "tree". Input The first line of input contains a single positive integer from 1 through 1000. It represents the number of data sets to follow. The processing for each data set is identical. The data sets appear on the following lines, one data set per line. For each data set, the line of input consists of three strings, separated by a single space. All strings are composed of upper and lower case letters only. The length of the third string is always the sum of the lengths of the first two strings. The first two strings will have lengths between 1 and 200 characters, inclusive. Output For each data set, print: Data set n: yes if the third string can be formed from the first two, or Data set n: no if it cannot. Of course n should be replaced by the data set number. See the sample output below for an example. Sample Input ~~~ 3 cat tree tcraete cat tree catrtee cat tree cttaree ~~~ Sample Output ~~~ Data set 1: yes Data set 2: yes Data set 3: no ~~~ **二:分析理解** 第三个字符串是否能由前两个字符串按照原有顺序不变的原则交叉构成。需要注意的是,visit数组元素值为1时,表示该位置已被访问过,下次无需访问。 **三:AC代码** ~~~ #define _CRT_SECURE_NO_DEPRECATE #define _CRT_SECURE_CPP_OVERLOAD_STANDARD_NAMES 1 #include<iostream> #include<string> #include<string.h> using namespace std; string str1, str2, str3; int len1, len2, len3; bool flag;//为真时,表示可以输出“yes” int visit[201][201];//标记数组,默认都是0 void DFS(int i, int j, int k); int main() { int N; cin >> N; for (int i = 1; i <= N; i++) { memset(visit, 0, sizeof(visit)); flag = false; cin >> str1 >> str2 >> str3; len1 = str1.length(); len2 = str2.length(); len3 = str3.length(); DFS(0, 0, 0); if (flag) cout << "Data set " << i << ": " << "yes\n"; else cout << "Data set " << i << ": " << "no\n"; } return 0; } void DFS(int i, int j, int k) { if (flag || visit[i][j])//如果为真或该点已被访问过 return; if (k == len3)//因为根据题意len1+len2=len3 { flag = true; return; } visit[i][j] = 1; if (i < len1 && str1[i] == str3[k]) DFS(i + 1, j, k + 1); if (j < len2 && str2[j] == str3[k]) DFS(i, j + 1, k + 1); } ~~~